/*=============================================
 * Farbwechseln
 *=============================================
 *
 * Lesen des Seriellen Einganges
 * die Werte in die Farbe des Fensters a:ndern
 *
 * http://dernulleffekt.de
 */


import processing.serial.*;  // die Library einlesen

float RotWert = 0;         // Variable fuer den Rotwert
float GruenWert = 0;       // Variable fuer den Gruentwert
float BlauWert = 0;        // Variable fuer den Blautwert

Serial Schnittstelle;      // Serielle Port festlegen

void setup() {
  size(800, 600);          // Fenstergrösse
  // Ausdrucken alle zur verfu:gungstehenden Seriellen Ports:
  println(Serial.list()); 
  // Den Seriellen Port des Arduinos 
  // in die nächste Funktion eintragen, 1,2 oder 3.
  // Seriellen Port o:ffnen, Baudrate festlegen:
  Schnittstelle = new Serial(this, Serial.list()[0], 9600); 
  // erst bei einem Zeilenumbruch, wird ein "serialEvent" gestartet:
  Schnittstelle.bufferUntil('\n');
}

void draw() {
  //Hintergrundfarbe in Abhaenigkeit der Werte darstellen:
  background(RotWert, GruenWert, BlauWert);
}

void serialEvent(Serial Schnittstelle) { 
  // den ASCII Wert abrufen:  
  String inString = Schnittstelle.readStringUntil('\n');
  if (inString != null) {
    inString = trim(inString); // alle Leerzeichen entferne
    //die Zeichenkette an den Kommatas teilen und in eine Tabelle legen:
    float[] colors = float(split(inString, ",")); 
    //wenn die Tabelle 3 Elemente beinhaltet, sind alle Daten ausgelesen:
    if (colors.length >=3) {
      // Uebertragen der Werte in 0 bis 255 und in die Variablen einsetzen:
      RotWert = map(colors[0], 0, 1023, 0, 255); 
      GruenWert = map(colors[1], 0, 1023, 0, 255);
      BlauWert = map(colors[2], 0, 1000, 0, 255);
    }
  }
}

